;*
;********************   ATtiny13***************************
;*
;*  ATtiny13A-10SU, RC -  9,6 
;*  ADC - 150  
;*
;* Timer_COMPA:      
;* Detect_movement:  
;* START:          
;* Read_ADC:         
;* Div10:          -   10
;* DIV42:          
;* PB0             
;* PB1             
;* PB2              
;* PB3             
;* PB4             
;*
;* Fuses          CKSEL=10, BODLEVEL=00
;*                  ,    0.
;***********************************************************************************

.nolist
.include "tn13def.inc"
.list

;***** *****

.def	m0 = r1        ;  /   
.def	m1 = r2     
.def	m2 = r3      
.def	m3 = r4      
.def	m4 = r5      
.def	m5 = r6      
.def	m6 = r7       
.def	m7 = r8       

.def	Save = r12     ;   SREG  

.def	t1	 = r16     ;   
.def	t2	 = r17     ;   
.def	Count6s = r18  ;  
.def	Cnt =  r19     ;   
.def	Count_Tm = r20 ;  
              

;*****  *****

.equ  ADSM = 0b11001110   ; ADEN,ADSC,ADIE,ADPS2=1,ADPS1=1,ADPS0=0
.equ  ADMX1 = 0b01000001  ; REFS0=1,Vref=1,1V, ADC1- 2


.cseg

.org 0
	rjmp Initial

.org 6
    rjmp Timer_COMPA     ; Timer0,   

		    
.org  $009               ;    ADC Complete
ldi   t1,(1<<SM0)        ; SE=0 ( "" ), SM1=0,SM0=1
out   MCUCR,t1           ; ""  =  
reti

Initial: ;  
	
    ldi   t1,(RamEnd)
    out   spl,t1	        ;  
	
   	ldi	t1,0b00000000   ; PB0-AIN0, PB1-AIN1, PB2-ADC1, PB3-Relay, PB4-Human Detect
	out	PORTB,t1        ; 
	ldi	t1,0b00001000		
	out	DDRB,t1	        ;
	 
;ldi t1,(1<<ACIS1) 
;out ACSR,t1             ;  ,   1  0  
ldi t1,250
out OCR0A,t1            ;    T0 
ldi Count6s,225         ;   
sei                     ;  
   ;    
ldi Count_Tm,10      ;   1 
ldi  t1,(1<<OCIE0A)
out  TIMSK0,t1       ;     T0
ldi  t1,(1<<WGM01)      
out  TCCR0A,t1       ;  
ldi  t1,(1<<PSR10)
out  GTCCR,t1       ;   T0
ldi  t1,(1<<CS02)|(1<<CS00)      
out  TCCR0B,t1       ;   T0   CK/1024
ldi  t1,0            ;    T0  
out  TCNT0,t1
Start1:              ;    
cpi Count_Tm,0
breq Detect_movement
rjmp Start1
rcall Read_ADC       ;     

Detect_movement: ;  

rcall Read_ADC      ;      
DM1:        
sbic PINB,4         ;   ,   Human Detect 
					;   ,  0
rjmp DM1            ;   0   Human Detect
in    t1,ACSR	    ;    ACSR
sbrs  t1,ACO	    ;   ,  1
rjmp  DM1           ;   
sbi PORTB,3         ;  

START:    ;  

lds Count_Tm,D2     ;    
ldi  t1,(1<<OCIE0A)
out  TIMSK0,t1      ;     T0
ldi  t1,(1<<WGM01)      
out  TCCR0A,t1       ;  
ldi  t1,(1<<PSR10)
out  GTCCR,t1       ;   T0
ldi  t1,(1<<CS02)|(1<<CS00)      
out  TCCR0B,t1       ;   T0   CK/1024
ldi  t1,0            ;    T0  
out  TCNT0,t1
Start0:              ;    
cpi Count_Tm,0
breq Detect_movement
rjmp Start0
 
Timer_COMPA:  ;    

in Save,SREG      ;    
    push t1
ldi  t1,0         ;    T0 
out  TCNT0,t1
dec Count6s       ;    
cpi Count6s,0
breq TI0          ; , 0
rjmp TI1
TI0:
ldi Count6s,225   ;   
dec Count_Tm      ;   
cpi Count_Tm,0
breq STOP
TI1:
  	pop t1
    out SREG,Save;    
reti
STOP:
ldi  t1,0
out  TIMSK0,t1       ;     T0
ldi  t1,0      
out  TCCR0B,t1       ;   T0 
cbi PORTB,3          ;  
ldi Count6s,225      ;   
  	pop t1
    out SREG,Save;    
reti

Read_ADC: ;    

ldi   t1,ADMX1         ;     , Ra  
out   ADMUX,t1
ldi   t1,ADSM          ;      
out   ADCSRA,t1
ldi  t1,(1<<SE)|(1<<SM0);  "" 
out  MCUCR,t1       
sleep                  ;   
in   m4,ADCL           ;   -
in   m5,ADCH           ;   -
ldi  t1,0b00001110     ;   
out  ADCSRA,t1
rcall Div10            ;   10
ret

Div10:  ;  -   10

;mov t1,m4
;andi t1,$FD     ; ""  
;mov m4,t1
ldi t1,0
mov m1,t1       
mov m6,t1       ;  , 
mov m7,t1
ldi t1,10
mov m0,t1
rcall DIV42
sts D2,m4       ;     
ret

DIV42:        ;  

ldi  t1,0x10

DCLK42:             ;   m7:m6:m5:m4
clc                 ;   m1:m0
mov  t2,m4          ;   m5:m4
rol  t2
mov  m4,t2
mov  t2,m5
rol  t2
mov  m5,t2
mov  t2,m6
rol  t2
mov  m6,t2
mov  t2,m7
rol  t2
mov  m7,t2
in   Cnt,SREG
push Cnt
PER1:
clc
mov  t2,m6
sbc  t2,m0
mov  m6,t2
mov  t2,m7
sbc  t2,m1
mov  m7,t2
brcs PER2
pop  Cnt
out  SREG,Cnt
PER3:
inc m4
rjmp PER4
PER2:
pop  Cnt
out  SREG,Cnt
brcs PER3
mov  t2,m6
add  t2,m0
mov  m6,t2
mov  t2,m7
adc  t2,m1
mov  m7,t2
PER4:
dec  t1
cpi  t1,0
brne DCLK42
ret


.dseg

D2: .byte 1    ;    

;***********************************************************************************

.Exit



