;*
;********************  *************************************
;*
;*  ATtiny13A, RC -  9,6 
;*   - 37,5 
;*
;* Main:           
;* UP_Power:        - 
;* Delay:           
;* TIMER0_COMPA:    - 
;* WDT: 		  -  

;* Fuses          CKSEL=10, BODLEVEL=11
;*                  ,    0.
;****************************************************************************

.nolist
.include "tn13def.inc"
.list

;***** *****

.def	Save = r12     ;   SREG  

.def	EEdwr = r14     ;      EEPROM
.def	EEdrd = r15     ;     EEPROM

.def	t1	 = r16     ;   
.def	t2	 = r17     ;   

.def	Value = r22    ;     
.def	TimeON = r23   ;     
.def	ImpScan = r24  ;     
.def	FormImp = r25  ;                 

;***** ***** 

.equ  StepLum = (-10)  ;    -
.equ  Lmin = 10        ;    -
.equ  Lmax = 100       ;    -
.equ  SetTime = 27     ;    

.cseg

.org 0
	rjmp Initial

;.org 1
;	rjmp UP_Power        ;   -

.org 6
	rjmp TIMER0_COMPA    ;  A / T0,Fast PWM

.org 8
	rjmp WDT             ; -  ,  

Initial: ;  
	
    ldi   t1,(RamEnd)
    out   spl,t1	    ;  
	
   	ldi	t1,0b00000010  
	out	PORTB,t1        ; PB0- ,PB1-SB2,PB2--,PB3-	
	ldi	t1,0b00001001	; PB4- 	
	out	DDRB,t1		     
    	    
ldi   t1,(1<<ACD)
out   ACSR,t1        ;   

;ldi   t1,(1<<INT0)
;out   GIMSK,t1       ;        INT0

ldi TimeON,SetTime   ;    
ldi t2,5             ;   EEPROM
rcall EERead	     ;  "  EEPROM"
mov Value,EEdrd      ;      
out OCR0A,Value      ;   
cpi Value,Lmax+1
brsh IM0
rjmp IM1
IM0:
ldi Value,Lmin
out OCR0A,Value      ;   
IM1:
sei                  ;  

Main:  ;  

wdr
ldi	t1,(1<<WDCE)
out	WDTCR,t1		 ;   
Main0:
clr ImpScan
sbis PinB,4          ;  , 1   
rjmp Main0
ldi  t1,0            ;    T0
out  TCNT0,t1
ldi  t1,(1<<OCIE0A)
out  TIMSK0,t1       ;     T0
ldi t1,(1<<CS00)     ;     CK = 9,6 MHz
out TCCR0B,t1
ldi t1,(1<<COM0A1)|(1<<WGM01)|(1<<WGM00) ;   T1,Fast PWM
out TCCR0A,t1
Main1:;   
cpi ImpScan,0b10101010
breq Main2
rjmp Main1
Main2:;  
clr ImpScan
sbi PORTB,3          ;  
wdr
ldi	t1,(1<<WDTIE)|(1<<WDCE)
out	WDTCR,t1		 ;   
wdr
ldi	t1,(1<<WDTIE)|(1<<WDP3) ;    4,0 
out	WDTCR,t1
Main3:
sbis PinB,1         ;   SB2  ,   
rcall UP_Power      ;   
cpi TimeON,0        ;    0
breq Main4          ;   ,  0
rjmp Main3          ;   ,   0
Main4:
ldi TimeON,SetTime  ;   
ldi t1,0            ;   
out TCCR0B,t1
rjmp Main

UP_Power:   ;   

    in Save,SREG     ;  
subi Value,StepLum   ;      
ldi t2,5             ;   EEPROM
rcall EEClear	     ;  " EEPROM"
ldi t2,5             ;   EEPROM
mov EEdwr,Value      ;      EEPROM
rcall EEWrite	     ;  "  EEPROM"  
ldi R20,$0E          ;     
ldi R19,$A6
ldi R18,$00
rcall Delay
out OCR0A,Value      ;   
cpi Value,Lmax       ;    
brsh UP0
    out SREG,Save    ;  
reti
UP0:
ldi Value,Lmin       ;   
ldi t2,5             ;   EEPROM
rcall EEClear	     ;  " EEPROM"
ldi t2,5             ;   EEPROM
mov EEdwr,Value      ;      EEPROM
rcall EEWrite	     ;  "  EEPROM"  
    out SREG,Save    ;  
reti

Delay:   ;   
subi R18,1
sbci R19,0
sbci R20,0
brcc Delay
ret

TIMER0_COMPA: ;    T0,Fast PWM 

   in Save,SREG      ;  
inc FormImp          ;    
cpi FormImp,7		 ;    
breq RL0
cpi FormImp,14		 ;   
breq RL1
cpi FormImp,116		 ;    
breq RL2
cpi FormImp,253      ;    
breq RL3
    out SREG,Save    ;  
reti
RL0:
sec              ;   C=1
sbic PinB,2      ;   ,   
clc              ;   C=0    
rol ImpScan      ;  
	out SREG,Save    ;  
reti
RL1:
ldi t1,(1<<WGM01)|(1<<WGM00) ;  T0    OC0A
out TCCR0A,t1
    out SREG,Save    ;  
reti
RL2:
clc              ;   C=0
sbis PinB,2      ;   ,   
sec              ;   C=1 
rol ImpScan      ;  
    out SREG,Save    ;  
reti
RL3:
clr FormImp
ldi t1,(1<<COM0A1)|(1<<WGM01)|(1<<WGM00) ;   T1,Fast PWM
out TCCR0A,t1
    out SREG,Save    ;  
reti

WDT: ; -  ,    

   in Save,SREG     ;  
dec TimeON        ;   
brne DT0          ;   ,   0
cbi PORTB,3       ;  
   out SREG,Save    ;  
reti
DT0:              ;   
   out SREG,Save    ;  
reti

EEClear:		;  " EEPROM"
                  
	sbic	EECR,EEPE	;  EEPE(EEWE)  . 0, 
	rjmp	EEClear	    ;    
		                ;     EEPROM -
cli 					;  
ldi t1,(1<<EEPM0)
out EECR,t1  
	out	EEAR,t2	        ;   
	out	EEDR,EEdwr	    ;   -    
	sbi	EECR,EEMPE	    ;  EEMPE(EEMWE)  
	sbi	EECR,EEPE	    ;  EEPE(EEWE) :  
				        ;     4- ,  
			        	;     2 
    sei                 ;  
	ret

EEWrite:		;  "  EEPROM"

    sbic	EECR,EEPE	;  EEPE(EEWE)  . 0, 
	rjmp	EEWrite		;    
		                ;     EEPROM -
cli                     ;  
ldi t1,(1<<EEPM1)
out EECR,t1  
	out	EEAR,t2	        ;   
	out	EEDR,EEdwr	    ;   -    
	sbi	EECR,EEMPE	    ;  EEMPE(EEMWE)  
	sbi	EECR,EEPE	    ;  EEPE(EEWE) :  
				        ;     4- ,  
			        	;     2 
    sei                 ;  
	ret

EERead:			;  " EEPROM"
                     
	sbic EECR,EEPE	    ;  EEPE(EEWE)  . 0, 
	rjmp EERead		    ;    
	           	        ;    EEPROM -
	out	EEAR,t2 	    ;    
	sbi	EECR,EERE	    ;   EEPE(EEWE)    .
				        ;   4 ,  
				        ;   2 
	in	EEdrd,EEDR	    ;   
   	ret
;*********************************************************************************
.Exit


